<template lang="pug">
.container
  .text-center
    md-button.md-raised.md-primary(@click="loadData()") Consulta
  div.md-scrollbar
    user-list(:userList="listedUsers")
  hr
  md-content
    span Filtros
    div
      md-checkbox(v-model="genderFilter" value="male" default="true") Hombre
      md-checkbox(v-model="genderFilter" value="female" default="true") Mujer
    md-field
      label Nacionalidad
      md-select(v-model="countryFilter" name="Pais" id="country" placeholder="Nacionalidad" multiple)
        md-option(v-for="country in nationalities" :value="country" :key="country") {{$t('countries.'+country)}}
    md-field
      label Edad
      md-input(type="range" v-model.number="ageFilter" :max="maxAge" :min="minAge") 
      span {{ ageFilter }}
</template>

<script>
import UserList from '../components/UserList'
export default {
  name: 'Vista1',
  components: {UserList},
  data () {
    return {
      userList: [],
      ageFilter: 0,
      countryFilter: ["NO","TR","ES","FR","US","DE","CH","IR","DK","NL","AU","FI","CA","IE","GB","BR","NZ"],
      genderFilter: ['male', 'female']
    }
  },
  mounted () {
    this.loadData();
  },
  methods: {
    loadData () {
      this.$randomUserService.getRandomUsers().then((res, err) => {
        this.userList = res.data.results;
      })
    }
  },
  computed: {
    nationalities () {
      return Array.from(new Set(this.userList.map(x => x.nat)));
    },
    minAge () {
      if (this.listedUsers.length) {
        const minDate = new Date(this.listedUsers.sort((x, y) => x.dob.date > y.dob.date ? -1 : 1)[0].dob.date);
        const now = new Date();
        let diff =(now.getTime() - minDate.getTime()) / 1000;
        diff /= (60 * 60 * 24);
        return Math.abs(Math.round(diff/365.25));
      }
    },
    maxAge () {
      if (this.listedUsers.length) {
        const maxDate = new Date(this.listedUsers.sort((x, y) => x.dob.date > y.dob.date ? 1 : -1)[0].dob.date);
        const now = new Date();
        let diff =(now.getTime() - maxDate.getTime()) / 1000;
        diff /= (60 * 60 * 24);
        return Math.abs(Math.round(diff/365.25));
      }
    },
    listedUsers () {
      return this.userList.filter(x => {
        let filters = true;
        filters = filters && this.countryFilter.includes(x.nat);
        filters = filters && this.genderFilter.includes(x.gender);
        return filters;
      });
    }
  }
}
</script>
<style scoped>
.md-scrollbar {
  max-height: 55vh;
  min-height: 55vh;
  padding-right: 0 !important;
  overflow: auto;
}
::-webkit-scrollbar {
  width: 0px;
  background: transparent; /* make scrollbar transparent */
}
</style>
